/*
 * Name: Mike Cifelli
 * Course: CIS 443 - Programming Languages
 * Assignment: Lisp Parser
 */

package sexpression;

/**
 * This class represents a SYMBOL in the PL-Lisp implementation.
 */
public class Symbol extends Atom {

    /** This SYMBOL represents TRUE in the PL-Lisp implementation. */
    public static final Symbol T = new Symbol("T");

    /**
     * Create a new SYMBOL with the specified text.
     *
     * @param text
     *  the text representing this SYMBOL
     */
    public Symbol(String text) {
        super(text.toUpperCase());
    }

    /**
     * Test if this S-expression is a SYMBOL.
     *
     * @return
     *  <code>true</code>
     */
    public boolean symbolp() {
        return true;
    }

}
