package token;

import file.FilePosition;

/**
 * A token in Lisp.
 */
public abstract class Token {

    public enum Type {
        LEFT_PAREN, RIGHT_PAREN, STRING, QUOTE_MARK, NUMBER, IDENTIFIER, EOF
    }

    private String text;
    private String fileName;
    private int line;
    private int column;

    public Token(String text, FilePosition position) {
        this.text = text;
        this.fileName = position.getFileName();
        this.line = position.getLineNumber();
        this.column = position.getColumnNumber();
    }

    public abstract Type getType();

    public String getText() {
        return text;
    }

    public String getFileName() {
        return fileName;
    }

    public int getLine() {
        return line;
    }

    public int getColumn() {
        return column;
    }

}
